diff --git a/Source/Core/Core/Src/HW/WiimoteEmu/WiimoteEmu.cpp b/Source/Core/Core/Src/HW/WiimoteEmu/WiimoteEmu.cpp
index 94e7d88..a0353ed 100644
--- a/Source/Core/Core/Src/HW/WiimoteEmu/WiimoteEmu.cpp
+++ b/Source/Core/Core/Src/HW/WiimoteEmu/WiimoteEmu.cpp
@@ -39,28 +39,7 @@ auto const PI = TAU / 2.0;
 namespace WiimoteEmu
 {
 
-/* An example of a factory default first bytes of the Eeprom memory. There are differences between
-   different Wiimotes, my Wiimote had different neutral values for the accelerometer. */
-static const u8 eeprom_data_0[] = {
-	// IR, maybe more
-	// assuming last 2 bytes are checksum
-	0xA1, 0xAA, 0x8B, 0x99, 0xAE, 0x9E, 0x78, 0x30, 0xA7, /*0x74, 0xD3,*/ 0x00, 0x00,	// messing up the checksum on purpose
-	0xA1, 0xAA, 0x8B, 0x99, 0xAE, 0x9E, 0x78, 0x30, 0xA7, /*0x74, 0xD3,*/ 0x00, 0x00,
-	// Accelerometer
-	// 0g x,y,z, 1g x,y,z, idk, last byte is a checksum
-	0x80, 0x80, 0x80, 0x00, 0x9A, 0x9A, 0x9A, 0x00, 0x40, 0xE3,
-	0x80, 0x80, 0x80, 0x00, 0x9A, 0x9A, 0x9A, 0x00, 0x40, 0xE3,
-};
-
-static const u8 motion_plus_id[] = { 0x00, 0x00, 0xA6, 0x20, 0x00, 0x05 };
-
-static const u8 eeprom_data_16D0[] = {
-	0x00, 0x00, 0x00, 0xFF, 0x11, 0xEE, 0x00, 0x00,
-	0x33, 0xCC, 0x44, 0xBB, 0x00, 0x00, 0x66, 0x99,
-	0x77, 0x88, 0x00, 0x00, 0x2B, 0x01, 0xE8, 0x13
-};
-
-const ReportFeatures reporting_mode_features[] = 
+const ReportFeatures reporting_mode_features[] =
 {
 	//0x30: Core Buttons
 	{ 2, 0, 0, 0, 4 },
@@ -97,19 +76,17 @@ void EmulateShake(AccelData* const accel
 
 	// peak G-force
 	double shake_intensity;
-	
-	// shake is a bitfield of X,Y,Z shake button states
-	static const unsigned int btns[] = { 0x01, 0x02, 0x04 };
-	unsigned int shake = 0;
-	buttons_group->GetState( &shake, btns );
+
+	ControlState button[3];
+	buttons_group->GetState( button );
 
 	for (int i = 0; i != 3; ++i)
 	{
-		if (shake & (1 << i))
+		if (button[i] != 0)
 		{
 			double zero = double((&(calib->zero_g.x))[i]);
 			double one = double((&(calib->one_g.x))[i]);
-			shake_intensity = max(zero / (one - zero), (255.f - zero) / (one - zero));
+			shake_intensity = button[i] * max(zero / (one - zero), (255.f - zero) / (one - zero));
 			(&(accel->x))[i] = std::sin(TAU * shake_step[i] / shake_step_max) * shake_intensity;
 			shake_step[i] = (shake_step[i] + 1) % shake_step_max;
 		}
@@ -120,11 +97,12 @@ void EmulateShake(AccelData* const accel
 
 void EmulateTilt(AccelData* const accel
 	, ControllerEmu::Tilt* const tilt_group
-	, const bool focus, const bool sideways, const bool upright)
+	, const bool focus, const bool sideways, const bool upright
+	, const bool fast)
 {
-	float roll, pitch;
+	float pitch, roll, yaw;
 	// 180 degrees
-	tilt_group->GetState(&roll, &pitch, 0, focus ? PI : 0);
+	tilt_group->GetState(&pitch, &roll, &yaw, false, 0.0, focus ? PI * tilt_group->settings[tilt_group->HasGyro() ? T_ACC_RANGE_S : T_RANGE]->value : 0);
 
 	unsigned int	ud = 0, lr = 0, fb = 0;
 
@@ -149,9 +127,22 @@ void EmulateTilt(AccelData* const accel
 	(&accel->x)[ud] = (sin((PI / 2) - std::max(fabsf(roll), fabsf(pitch))))*sgn[ud];
 	(&accel->x)[lr] = -sin(roll)*sgn[lr];
 	(&accel->x)[fb] = sin(pitch)*sgn[fb];
+
+	// rotation g-force
+	if (tilt_group->HasGyro()
+		&& (tilt_group->controls[T_FAST]->control_ref->State() != 0
+		|| fast))
+	{
+		tilt_group->GetState( &pitch, &roll, &yaw, true, 0.0, focus ? 1.0 : 0, false );
+		if (abs(yaw) > 0 || abs(pitch) > 0)		accel->y += 5;
+		if (yaw > 0)							accel->x += 5;
+		if (yaw < 0)							accel->x -= 5;
+		if (pitch > 0)							accel->z += 5;
+		if (pitch < 0)							accel->z -= 5;
+	}
 }
 
-#define SWING_INTENSITY		2.5f//-uncalibrated(aprox) 0x40-calibrated
+#define SWING_INTENSITY		5.0f//-uncalibrated(aprox) 0x40-calibrated
 
 void EmulateSwing(AccelData* const accel
 	, ControllerEmu::Force* const swing_group
@@ -204,6 +195,16 @@ const char* const named_buttons[] =
 	"A", "B", "1", "2", "-", "+", "Home",
 };
 
+bool Wiimote::GetMotionPlusAttached() const
+{
+	return m_options->settings[SETTING_MOTIONPLUS]->value != 0;
+}
+
+bool Wiimote::GetMotionPlusActive() const
+{
+	return m_reg_motion_plus.ext_identifier[2] == 0xa4;
+}
+
 void Wiimote::Reset()
 {
 	m_reporting_mode = WM_REPORT_CORE;
@@ -213,9 +214,7 @@ void Wiimote::Reset()
 
 	m_rumble_on = false;
 	m_speaker_mute = false;
-	m_motion_plus_present = false;
-	m_motion_plus_active = false;
-
+	mp_passthrough = false;
 	// will make the first Update() call send a status request
 	// the first call to RequestStatus() will then set up the status struct extension bit
 	m_extension->active_extension = -1;
@@ -233,7 +232,9 @@ void Wiimote::Reset()
 	memset(&m_reg_ext, 0, sizeof(m_reg_ext));
 	memset(&m_reg_motion_plus, 0, sizeof(m_reg_motion_plus));
 
-	memcpy(&m_reg_motion_plus.ext_identifier, motion_plus_id, sizeof(motion_plus_id));
+	memcpy(&m_reg_motion_plus.calibration, motion_plus_calibration, sizeof(motion_plus_calibration));
+	memcpy(&m_reg_motion_plus.gyro_calib, mp_gyro_calib, sizeof(mp_gyro_calib));
+	memcpy(&m_reg_motion_plus.ext_identifier, mp_id, sizeof(mp_id));
 
 	// status
 	memset(&m_status, 0, sizeof(m_status));
@@ -262,13 +263,17 @@ Wiimote::Wiimote( const unsigned int index )
 {
 	// ---- set up all the controls ----
 
+	m_udp = new UDPWrapper(m_index, _trans("UDP Wiimote"));
+
 	// buttons
 	groups.push_back(m_buttons = new Buttons("Buttons"));
 	for (unsigned int i=0; i < sizeof(named_buttons)/sizeof(*named_buttons); ++i)
 		m_buttons->controls.push_back(new ControlGroup::Input( named_buttons[i]));
 
-	// udp
-	groups.push_back(m_udp = new UDPWrapper(m_index, _trans("UDP Wiimote")));
+	// dpad
+	groups.push_back(m_dpad = new Buttons("D-Pad"));
+	for (unsigned int i=0; i < 4; ++i)
+		m_dpad->controls.push_back(new ControlGroup::Input(named_directions[i]));
 
 	// ir
 	groups.push_back(m_ir = new Cursor(_trans("IR")));
@@ -276,23 +281,23 @@ Wiimote::Wiimote( const unsigned int index )
 	// swing
 	groups.push_back(m_swing = new Force(_trans("Swing")));
 
-	// tilt
-	groups.push_back(m_tilt = new Tilt(_trans("Tilt")));
-
 	// shake
-	groups.push_back(m_shake = new Buttons(_trans("Shake")));
+	groups.push_back(m_shake = new Buttons(_trans("Shake"), true));
 	m_shake->controls.push_back(new ControlGroup::Input("X"));
 	m_shake->controls.push_back(new ControlGroup::Input("Y"));
 	m_shake->controls.push_back(new ControlGroup::Input("Z"));
 
+	// tilt
+	groups.push_back(m_tilt = new Tilt(_trans("Tilt"), true));
+
 	// extension
 	groups.push_back(m_extension = new Extension(_trans("Extension")));
-	m_extension->attachments.push_back(new WiimoteEmu::None(m_reg_ext));
-	m_extension->attachments.push_back(new WiimoteEmu::Nunchuk(m_udp, m_reg_ext));
-	m_extension->attachments.push_back(new WiimoteEmu::Classic(m_reg_ext));
-	m_extension->attachments.push_back(new WiimoteEmu::Guitar(m_reg_ext));
-	m_extension->attachments.push_back(new WiimoteEmu::Drums(m_reg_ext));
-	m_extension->attachments.push_back(new WiimoteEmu::Turntable(m_reg_ext));
+	m_extension->attachments.push_back(new WiimoteEmu::None());
+	m_extension->attachments.push_back(new WiimoteEmu::Nunchuk(m_udp));
+	m_extension->attachments.push_back(new WiimoteEmu::Classic());
+	m_extension->attachments.push_back(new WiimoteEmu::Guitar());
+	m_extension->attachments.push_back(new WiimoteEmu::Drums());
+	m_extension->attachments.push_back(new WiimoteEmu::Turntable());
 
 	m_extension->settings.push_back(new ControlGroup::Setting(_trans("Motion Plus"), 0, 0, 1));
 
@@ -300,16 +305,17 @@ Wiimote::Wiimote( const unsigned int index )
 	groups.push_back(m_rumble = new ControlGroup(_trans("Rumble")));
 	m_rumble->controls.push_back(new ControlGroup::Output(_trans("Motor")));
 
-	// dpad
-	groups.push_back(m_dpad = new Buttons("D-Pad"));
-	for (unsigned int i=0; i < 4; ++i)
-		m_dpad->controls.push_back(new ControlGroup::Input(named_directions[i]));
-
 	// options
-	groups.push_back( m_options = new ControlGroup(_trans("Options")));
+	groups.push_back(m_options = new ControlGroup(_trans("Options"), GROUP_TYPE_OPTIONS));
 	m_options->settings.push_back(new ControlGroup::Setting(_trans("Background Input"), false));
 	m_options->settings.push_back(new ControlGroup::Setting(_trans("Sideways Wiimote"), false));
 	m_options->settings.push_back(new ControlGroup::Setting(_trans("Upright Wiimote"), false));
+	m_options->settings.push_back(new ControlGroup::Setting(_trans("MotionPlus"), false));
+	m_options->settings.push_back(new ControlGroup::Setting(_trans("MotionPlus Fast"), false));
+	m_options->settings.push_back(new ControlGroup::Setting(_trans("Hide IR"), false));
+
+	// udp
+	groups.push_back(m_udp);
 
 	// TODO: This value should probably be re-read if SYSCONF gets changed
 	m_sensor_bar_on_top = SConfig::GetInstance().m_SYSCONF->GetData<u8>("BT.BAR") != 0;
@@ -330,9 +336,6 @@ bool Wiimote::Step()
 {
 	const bool has_focus = HAS_FOCUS;
 
-	// TODO: change this a bit
-	m_motion_plus_present = m_extension->settings[0]->value != 0;
-
 	// no rumble if no focus
 	if (false == has_focus)
 		m_rumble_on = false;
@@ -378,6 +381,12 @@ bool Wiimote::Step()
 
 		return true;
 	}
+	// m+ switch
+	if (GetMotionPlusActive() && !GetMotionPlusAttached()) {
+		RequestStatus(NULL, 0);
+		if (m_extension->active_extension != EXT_NONE)
+			RequestStatus();
+	}
 
 	return false;
 }
@@ -385,16 +394,25 @@ bool Wiimote::Step()
 void Wiimote::UpdateButtonsStatus(bool has_focus)
 {
 	// update buttons in status struct
-	m_status.buttons = 0;
+	memset(&m_status.buttons, 0, sizeof(m_status.buttons));
 	if (has_focus)
 	{
 		const bool is_sideways = m_options->settings[1]->value != 0;
-		m_buttons->GetState(&m_status.buttons, button_bitmasks);
-		m_dpad->GetState(&m_status.buttons, is_sideways ? dpad_sideways_bitmasks : dpad_bitmasks);
-		UDPTLayer::GetButtons(m_udp, &m_status.buttons);
+		m_buttons->GetState((u16*)&m_status.buttons, button_bitmasks);
+		m_dpad->GetState((u16*)&m_status.buttons, is_sideways ? dpad_sideways_bitmasks : dpad_bitmasks);
+		UDPTLayer::GetButtons(m_udp, (u16*)&m_status.buttons);
 	}
 }
 
+void Wiimote::GetSettings()
+{
+	std::vector<ControlGroup::Setting*>::const_iterator
+			si = m_options->settings.begin(),
+			se = m_options->settings.end();
+		for (; si!=se; ++si)
+			(*si)->GetState();
+}
+
 void Wiimote::GetCoreData(u8* const data)
 {
 	// when a movie is active, the button update happens here instead of Wiimote::Step, to avoid potential desync issues.
@@ -403,18 +421,18 @@ void Wiimote::GetCoreData(u8* const data)
 		UpdateButtonsStatus(HAS_FOCUS);
 	}
 
-	*(wm_core*)data |= m_status.buttons;
+	memcpy(data, &m_status.buttons, sizeof(m_status.buttons));
 }
 
 void Wiimote::GetAccelData(u8* const data, u8* const buttons)
 {
 	const bool has_focus = HAS_FOCUS;
-	const bool is_sideways = m_options->settings[1]->value != 0;
-	const bool is_upright = m_options->settings[2]->value != 0;
+	const bool is_sideways = m_options->settings[SETTING_SIDEWAYS_WIIMOTE]->value != 0;
+	const bool is_upright = m_options->settings[SETTING_UPRIGHT_WIIMOTE]->value != 0;
 	accel_cal* calib = (accel_cal*)&m_eeprom[0x16];
 
 	// ----TILT----
-	EmulateTilt(&m_accel, m_tilt, has_focus, is_sideways, is_upright);
+	EmulateTilt(&m_accel, m_tilt, has_focus, is_sideways, is_upright, m_options->settings[SETTING_MOTIONPLUS_FAST]->value != 0);
 
 	// ----SWING----
 	// ----SHAKE----
@@ -424,11 +442,18 @@ void Wiimote::GetAccelData(u8* const data, u8* const buttons)
 		EmulateShake(&m_accel, calib, m_shake, m_shake_step);
 		UDPTLayer::GetAcceleration(m_udp, &m_accel);
 	}
+
 	wm_accel* dt = (wm_accel*)data;
 	double cx,cy,cz;
-	cx=trim(m_accel.x*(calib->one_g.x-calib->zero_g.x)+calib->zero_g.x);
-	cy=trim(m_accel.y*(calib->one_g.y-calib->zero_g.y)+calib->zero_g.y);
-	cz=trim(m_accel.z*(calib->one_g.z-calib->zero_g.z)+calib->zero_g.z);
+	//cx=Common::trim8(m_accel.x*(calib->one_g.x-calib->zero_g.x)+calib->zero_g.x);
+	//cy=Common::trim8(m_accel.y*(calib->one_g.y-calib->zero_g.y)+calib->zero_g.y);
+	//cz=Common::trim8(m_accel.z*(calib->one_g.z-calib->zero_g.z)+calib->zero_g.z);
+	cx=m_accel.x*(calib->one_g.x-calib->zero_g.x)+calib->zero_g.x;
+	cx=(cx <= 0 ? 0 : (cx >= 0xff ? 0xff : cx));
+	cy=m_accel.y*(calib->one_g.y-calib->zero_g.y)+calib->zero_g.y;
+	cy=(cy <= 0 ? 0 : (cy >= 0xff ? 0xff : cy));
+	cz=m_accel.z*(calib->one_g.z-calib->zero_g.z)+calib->zero_g.z;
+	cz=(cz <= 0 ? 0 : (cz >= 0xff ? 0xff : cz));
 	dt->x=u8(cx);
 	dt->y=u8(cy);
 	dt->z=u8(cz);
@@ -448,6 +473,14 @@ inline void LowPassFilter(double & var, double newval, double period)
 
 void Wiimote::GetIRData(u8* const data, bool use_accel)
 {
+	if ((m_options->settings[SETTING_IR_HIDE]->value != 0
+		|| m_ir->controls[C_HIDE]->control_ref->State())
+		&& !m_ir->controls[C_SHOW]->control_ref->State())
+	{
+		memset(data, 0xFF, 10);
+		return;
+	}
+
 	const bool has_focus = HAS_FOCUS;
 
 	u16 x[4], y[4];
@@ -457,7 +490,7 @@ void Wiimote::GetIRData(u8* const data, bool use_accel)
 	{
 		float xx = 10000, yy = 0, zz = 0;
 		double nsin,ncos;
-		
+
 		if (use_accel)
 		{
 			double ax,az,len;
@@ -466,7 +499,7 @@ void Wiimote::GetIRData(u8* const data, bool use_accel)
 			len=sqrt(ax*ax+az*az);
 			if (len)
 			{
-				ax/=len; 
+				ax/=len;
 				az/=len; //normalizing the vector
 				nsin=ax;
 				ncos=az;
@@ -489,17 +522,17 @@ void Wiimote::GetIRData(u8* const data, bool use_accel)
 		LowPassFilter(ir_sin,nsin,1.0f/60);
 		LowPassFilter(ir_cos,ncos,1.0f/60);
 
-		m_ir->GetState(&xx, &yy, &zz, true);
+		m_ir->GetState(&xx, &yy, &zz, m_ir->settings[C_RANGE]->value, true, false, true);
 		UDPTLayer::GetIR(m_udp, &xx, &yy, &zz);
 
 		Vertex v[4];
-		
+
 		static const int camWidth=1024;
 		static const int camHeight=768;
-		static const double bndup=-0.315447;	
-		static const double bnddown=0.85;	
-		static const double bndleft=0.443364;		
-		static const double bndright=-0.443364;	
+		static const double bndup=-0.315447;
+		static const double bnddown=0.85;
+		static const double bndleft=0.443364;
+		static const double bndright=-0.443364;
 		static const double dist1=100.f/camWidth; //this seems the optimal distance for zelda
 		static const double dist2=1.2f*dist1;
 
@@ -553,7 +586,7 @@ void Wiimote::GetIRData(u8* const data, bool use_accel)
 		wm_ir_basic* const irdata = (wm_ir_basic*)data;
 		for (unsigned int i=0; i<2; ++i)
 		{
-			if (x[i*2] < 1024 && y[i*2] < 768) 
+			if (x[i*2] < 1024 && y[i*2] < 768)
 			{
 				irdata[i].x1 = u8(x[i*2]);
 				irdata[i].x1hi = x[i*2] >> 8;
@@ -600,51 +633,160 @@ void Wiimote::GetIRData(u8* const data, bool use_accel)
 
 void Wiimote::GetExtData(u8* const data)
 {
-	m_extension->GetState(data, HAS_FOCUS);
-
-	// i dont think anything accesses the extension data like this, but ill support it. Indeed, commercial games don't do this.
-	// i think it should be unencrpyted in the register, encrypted when read.
-	memcpy(m_reg_ext.controller_data, data, sizeof(wm_extension));
-
 	// motionplus pass-through modes
-	if (m_motion_plus_active)
+	if (GetMotionPlusActive())
 	{
-		switch (m_reg_motion_plus.ext_identifier[0x4])
+		if (mp_passthrough && m_extension->active_extension != EXT_NONE)
 		{
-		// nunchuck pass-through mode
-		// Bit 7 of byte 5 is moved to bit 6 of byte 5, overwriting it
-		// Bit 0 of byte 4 is moved to bit 7 of byte 5
-		// Bit 3 of byte 5 is moved to bit 4 of byte 5, overwriting it
-		// Bit 1 of byte 5 is moved to bit 3 of byte 5
-		// Bit 0 of byte 5 is moved to bit 2 of byte 5, overwriting it 
-		case 0x5:
-			//data[5] & (1 << 7)
-			//data[4] & (1 << 0)
-			//data[5] & (1 << 3)
-			//data[5] & (1 << 1)
-			//data[5] & (1 << 0)
-			break;
+			m_extension->GetState(data, HAS_FOCUS);
+			memcpy(m_reg_ext.controller_data, data, sizeof(wm_nc));
+			wm_nc* nc = (wm_nc*)data;
+			wm_nc_mp* nc_mp = (wm_nc_mp*)data;
 
-		// classic controller/musical instrument pass-through mode
-		// Bit 0 of Byte 4 is overwritten
-		// Bits 0 and 1 of Byte 5 are moved to bit 0 of Bytes 0 and 1, overwriting
-		case 0x7:
-			//data[4] & (1 << 0)
-			//data[5] & (1 << 0)
-			//data[5] & (1 << 1)
-			break;
+			switch (m_reg_motion_plus.ext_identifier[0x4])
+			{
+			// nunchuck pass-through mode
+			case 0x5:
+				nc_mp->jx = nc->jx;
+				nc_mp->jy = nc->jy;
+				nc_mp->ax = nc->ax;
+				nc_mp->ay = nc->ay;
+				nc_mp->az = nc->az >> 1;
+				nc_mp->azL = nc->az & 1;
+				nc_mp->bz = nc->bt.z;
+				nc_mp->bc = nc->bt.c;
+				nc_mp->is_mp_data = 0;
+				nc_mp->extension_connected = 1;
+				nc_mp->dummy = 0;
+				break;
+
+			// classic controller/musical instrument pass-through mode
+			// Bit 0 of Byte 4 is overwritten
+			// Bits 0 and 1 of Byte 5 are moved to bit 0 of Bytes 0 and 1, overwriting
+			case 0x7:
+				//data[4] & (1 << 0)
+				//data[5] & (1 << 0)
+				//data[5] & (1 << 1)
+				break;
+
+			// unknown pass-through mode
+			default:
+				break;
+			}
+		}
+		else
+		{
+			accel_cal* calib = (accel_cal*)&m_eeprom[0x16];
 
-		// unknown pass-through mode
-		default:
-			break;
+			memset(data, 0, sizeof(wm_motionplus));
+			wm_motionplus* mp = (wm_motionplus*)data;
+
+			AccelData sh;
+			memset(&sh, 0, sizeof(sh));
+			static u8 m_shake_step_mp[3];
+			float ry = 0, rp = 0, rr = 0;
+			float p = 0, r = 0, y = 0;
+			static u16 _p, _r, _y;
+
+			const bool is_sideways = m_options->settings[SETTING_SIDEWAYS_WIIMOTE]->value != 0;
+			const bool is_upright = m_options->settings[SETTING_UPRIGHT_WIIMOTE]->value != 0;
+			const bool fast = m_tilt->controls[T_FAST]->control_ref->State() != 0
+					|| m_options->settings[SETTING_MOTIONPLUS_FAST]->value != 0;
+
+			if (HAS_FOCUS)
+			{
+				// shake
+				EmulateShake(&sh, calib, m_shake, m_shake_step_mp);
+				for (unsigned int i=0; i<3; ++i)
+					(&(sh.x))[i] *= m_shake->settings[B_RANGE]->value;
+
+				// tilt
+				m_tilt->GetState(&rp, &rr, &ry, true, 0, 1.0, false);
+				//rp = MathUtil::Trim(rp, -1, 1);
+				rp = (rp < -1 ? -1 : (rp > 1 ? 1 : rp));
+				//rr = MathUtil::Trim(rr, -1, 1);
+				rr = (rr < -1 ? -1 : (rr > 1 ? 1 : rr));
+				//ry = MathUtil::Trim(ry, -1, 1);
+				ry = (ry < -1 ? -1 : (ry > 1 ? 1 : ry));
+
+				// gyro controls
+				p = +rp	+sh.y;
+				r = -rr	-sh.z;
+				y = -ry	-sh.x;
+			}
+
+			// fast or slow
+			if (!fast)
+			{
+				mp->pitch_slow = 1;
+				mp->roll_slow = 1;
+				mp->yaw_slow = 1;
+			}
+
+			// report
+			//_p = Common::trim14(p * 0x1fff + 0x1f7f);
+			_p = p * 0x1fff + 0x1f7f;
+			_p = (_p <= 0 ? 0 : (_p >= 0x3fff ? 0x3fff : _p));
+			//_r = Common::trim14(r * 0x1fff + 0x1f7f);
+			_r = r * 0x1fff + 0x1f7f;
+			_r = (_r <= 0 ? 0 : (_r >= 0x3fff ? 0x3fff : _r));
+			//_y = Common::trim14(y * 0x1fff + 0x1f7f);
+			_y = y * 0x1fff + 0x1f7f;
+			_y = (_y <= 0 ? 0 : (_y >= 0x3fff ? 0x3fff : _y));
+			mp->pitch1 = _p & 0xff; mp->pitch2 = ((_p >> 8) & 0x3f);
+			mp->roll1 = _r & 0xff; mp->roll2 = ((_r >> 8) & 0x3f);
+			mp->yaw1 = _y & 0xff; mp->yaw2 = ((_y >> 8) & 0x3f);
+			mp->is_mp_data = 1;
+			mp->extension_connected = (m_extension->active_extension != EXT_NONE) ? 1 : 0;
+			mp->dummy = 0;
+
+#if 0
+			// log
+			float mx = 0, my = 0, mz = 0;
+			m_ir->GetState(&mx, &my, &mz, 0, false, false, false);
+
+			AccelData n_accel;
+			memset(&n_accel, 0, sizeof(n_accel));
+			if (m_extension->active_extension > 0)
+				n_accel = ((WiimoteEmu::Nunchuk*)m_extension->attachments[m_extension->active_extension])->m_accel;
+			accel_cal* n_calib = (accel_cal*)&((WiimoteEmu::Nunchuk*)m_extension->attachments[m_extension->active_extension])->reg[0x20];
+			NOTICE_LOG_S(CONSOLE,
+			"%5.2f %5.2f%s"
+			//" | %02x %02x %02x"
+			" | %5.2f %5.2f %5.2f"
+			//" | %02x %02x %02x"
+			" | %5.2f %5.2f %5.2f"
+			//" | %5.2f %5.2f %5.2f"
+			" | %5.2f %5.2f %5.2f"
+			//" | %4x %4x %4x"
+			" %s%s%s"
+			//" (%02x %02x %02x %02x %02x %02x)",
+				, mx, my, (m_options->settings[SETTING_IR_HIDE]->value != 0 ? "*" : " ")
+				, m_accel.x, m_accel.y, m_accel.z
+				//, (u8)trim(m_accel.x*(calib->one_g.x-calib->zero_g.x)+calib->zero_g.x), (u8)trim(m_accel.y*(calib->one_g.y-calib->zero_g.y)+calib->zero_g.y), (u8)trim(m_accel.z*(calib->one_g.z-calib->zero_g.z)+calib->zero_g.z)
+				, n_accel.x, n_accel.y, n_accel.z
+				//, (u8)trim(n_accel.x*(n_calib->one_g.x-n_calib->zero_g.x)+n_calib->zero_g.x), (u8)trim(n_accel.y*(n_calib->one_g.y-n_calib->zero_g.y)+n_calib->zero_g.y), (u8)trim(n_accel.z*(n_calib->one_g.z-n_calib->zero_g.z)+n_calib->zero_g.z)
+				//, sh.y, sh.z, sh.x
+				//, rp, rr, ry
+				, p, r, y
+				//, _p, _r, _y
+				//, mp->yaw1, mp->yaw2, mp->pitch1, mp->pitch2, mp->roll1, mp->roll2
+				, mp->pitch_slow ? "*":" ", mp->roll_slow ? "*":" ", mp->yaw_slow ? "*":" "
+				);
+#endif
 		}
 
-		((wm_motionplus_data*)data)->is_mp_data = 0;
-		((wm_motionplus_data*)data)->extension_connected = m_extension->active_extension;
+		mp_passthrough = !mp_passthrough;
+	}
+	else
+	{
+		m_extension->GetState(data, HAS_FOCUS);
+		// i dont think anything accesses the extension data like this, but ill support it. Indeed, commercial games don't do this.
+		// i think it should be unencrpyted in the register, encrypted when read.
+		memcpy(m_reg_ext.controller_data, data, sizeof(wm_nc));
+		if (0xAA == m_reg_ext.encryption)
+			wiimote_encrypt(&m_ext_key, data, 0x00, sizeof(wm_nc));
 	}
-
-	if (0xAA == m_reg_ext.encryption)
-		wiimote_encrypt(&m_ext_key, data, 0x00, sizeof(wm_extension));
 }
 
 void Wiimote::Update()
@@ -659,7 +801,7 @@ void Wiimote::Update()
 
 	u8 data[MAX_PAYLOAD];
 	memset(data, 0, sizeof(data));
-	
+
 	// figure out what data we need
 	s8 rptf_size = MAX_PAYLOAD;
 
@@ -676,28 +818,30 @@ void Wiimote::Update()
 	{
 		data[0] = 0xA1;
 		data[1] = m_reporting_mode;
-	
+
+		GetSettings();
+
 		// core buttons
 		if (rptf.core)
 			GetCoreData(data + rptf.core);
-	
+
 		// acceleration
 		if (rptf.accel)
 			GetAccelData(data + rptf.accel, rptf.core?(data+rptf.core):NULL);
-	
+
 		// IR
 		if (rptf.ir)
-			GetIRData(data + rptf.ir, (rptf.accel != 0)); 
-	
+			GetIRData(data + rptf.ir, (rptf.accel != 0));
+
 		// extension
 		if (rptf.ext)
 			GetExtData(data + rptf.ext);
-	
+
 		// hybrid wiimote stuff (for now, it's not supported while recording)
 		if (WIIMOTE_SRC_HYBRID == g_wiimote_sources[m_index] && !Movie::IsRecordingInput())
 		{
 			using namespace WiimoteReal;
-	
+
 			std::lock_guard<std::recursive_mutex> lk(g_refresh_lock);
 			if (g_wiimotes[m_index])
 			{
@@ -712,31 +856,31 @@ void Wiimote::Update()
 						if (real_data[1] >= WM_REPORT_CORE)
 						{
 							const ReportFeatures& real_rptf = reporting_mode_features[real_data[1] - WM_REPORT_CORE];
-	
+
 							// force same report type from real-wiimote
 							if (&real_rptf != &rptf)
 								rptf_size = 0;
-	
+
 							// core
 							// mix real-buttons with emu-buttons in the status struct, and in the report
 							if (real_rptf.core && rptf.core)
 							{
-								m_status.buttons |= *(wm_core*)(real_data + real_rptf.core);
-								*(wm_core*)(data + rptf.core) = m_status.buttons;
+								memcpy(&m_status.buttons, real_data + real_rptf.core, sizeof(m_status.buttons));
+								memcpy(data + rptf.core, &m_status.buttons, sizeof(m_status.buttons));
 							}
-	
+
 							// accel
 							// use real-accel data always i guess
 							if (real_rptf.accel && rptf.accel)
 								memcpy(data + rptf.accel, real_data + real_rptf.accel, sizeof(wm_accel));
-	
+
 							// ir
 							// TODO
-	
+
 							// ext
 							// use real-ext data if an emu-extention isn't chosen
 							if (real_rptf.ext && rptf.ext && (0 == m_extension->switch_extension))
-								memcpy(data + rptf.ext, real_data + real_rptf.ext, sizeof(wm_extension));
+								memcpy(data + rptf.ext, real_data + real_rptf.ext, sizeof(wm_nc));
 						}
 						else if (WM_ACK_DATA != real_data[1] || m_extension->active_extension > 0)
 							rptf_size = 0;
@@ -744,7 +888,7 @@ void Wiimote::Update()
 							// use real-acks if an emu-extension isn't chosen
 							rptf_size = -1;
 						break;
-	
+
 						// use all status reports, after modification of the extension bit
 					case WM_STATUS_REPORT :
 						//if (m_extension->switch_extension)
@@ -753,14 +897,14 @@ void Wiimote::Update()
 							((wm_status_report*)(real_data + 2))->extension = 1;
 						rptf_size = -1;
 						break;
-	
+
 						// use all read-data replies
 					case WM_READ_DATA_REPLY:
 						rptf_size = -1;
 						break;
-	
+
 					}
-	
+
 					// copy over report from real-wiimote
 					if (-1 == rptf_size)
 					{
@@ -794,7 +938,7 @@ void Wiimote::Update()
 	}
 }
 
-void Wiimote::ControlChannel(const u16 _channelID, const void* _pData, u32 _Size) 
+void Wiimote::ControlChannel(const u16 _channelID, const void* _pData, u32 _Size)
 {
 	// Check for custom communication
 	if (99 == _channelID)
@@ -823,7 +967,7 @@ void Wiimote::ControlChannel(const u16 _channelID, const void* _pData, u32 _Size
 	case HID_TYPE_SET_REPORT :
 		if (HID_PARAM_INPUT == hidp->param)
 		{
-			PanicAlert("HID_TYPE_SET_REPORT - INPUT"); 
+			PanicAlert("HID_TYPE_SET_REPORT - INPUT");
 		}
 		else
 		{
@@ -832,6 +976,7 @@ void Wiimote::ControlChannel(const u16 _channelID, const void* _pData, u32 _Size
 			HidOutputReport((wm_report*)hidp->data);
 
 			u8 handshake = HID_HANDSHAKE_SUCCESS;
+			WiimoteEmu::Spy(this, &handshake, 1);
 			Core::Callback_WiimoteInterruptChannel(m_index, _channelID, &handshake, 1);
 		}
 		break;
@@ -849,6 +994,8 @@ void Wiimote::ControlChannel(const u16 _channelID, const void* _pData, u32 _Size
 
 void Wiimote::InterruptChannel(const u16 _channelID, const void* _pData, u32 _Size)
 {
+	Spy(this, _pData, _Size);
+
 	// this all good?
 	m_reporting_channel = _channelID;
 
diff --git a/Source/Core/Core/Src/HW/WiimoteEmu/WiimoteEmu.h b/Source/Core/Core/Src/HW/WiimoteEmu/WiimoteEmu.h
index 9ed58f8..ded1339 100644
--- a/Source/Core/Core/Src/HW/WiimoteEmu/WiimoteEmu.h
+++ b/Source/Core/Core/Src/HW/WiimoteEmu/WiimoteEmu.h
@@ -32,6 +32,58 @@ class Wiimote;
 namespace WiimoteEmu
 {
 
+/* An example of a factory default first bytes of the Eeprom memory. There are differences between
+   different Wiimotes, my Wiimote had different neutral values for the accelerometer. */
+static const u8 eeprom_data_0[] = {
+	// IR, maybe more
+	// assuming last 2 bytes are checksum
+	0xA1, 0xAA, 0x8B, 0x99, 0xAE, 0x9E, 0x78, 0x30, 0xA7, /*0x74, 0xD3,*/ 0x00, 0x00,	// messing up the checksum on purpose - why?
+	0xA1, 0xAA, 0x8B, 0x99, 0xAE, 0x9E, 0x78, 0x30, 0xA7, /*0x74, 0xD3,*/ 0x00, 0x00,
+	// Accelerometer
+	// 0g x,y,z, 1g x,y,z, idk, last byte is a checksum
+	0x80, 0x80, 0x80, 0x00, 0x9A, 0x9A, 0x9A, 0x00, 0x40, 0xE3,
+	0x80, 0x80, 0x80, 0x00, 0x9A, 0x9A, 0x9A, 0x00, 0x40, 0xE3,
+};
+
+static const u8 eeprom_data_16D0[] = {
+	0x00, 0x00, 0x00, 0xFF, 0x11, 0xEE, 0x00, 0x00,
+	0x33, 0xCC, 0x44, 0xBB, 0x00, 0x00, 0x66, 0x99,
+	0x77, 0x88, 0x00, 0x00, 0x2B, 0x01, 0xE8, 0x13
+};
+
+static const u8 mp_id[] = { 0x00, 0x00, 0xA6, 0x20, 0x00, 0x05 };
+
+/* Default calibration for the motion plus, 0xA60020 */
+static const u8 motion_plus_calibration[] =
+{
+	0x7b, 0xec, 0x76, 0xca, 0x76, 0x2c, // gyroscope neutral values (each 14 bit, last 2bits unknown) fast motion p/r/y
+	0x32, 0xdc, 0xcc, 0xd7,				// "" min/max p
+	0x2e, 0xa8, 0xc8, 0x77,				// "" min/max r
+	0x5e, 0x02,
+
+	0x76, 0x0f, 0x79, 0x3d, 0x77, 0x9b, // gyroscope neutral values (each 14 bit, last 2bits unknown) slow motion
+	0x39, 0x43, 0xca, 0xa8,				// "" min/max p
+	0x31, 0xc8,							// "" min r
+	0x2d, 0x1c, 0xbc, 0x33
+}; // TODO: figure out remaining parts;
+
+// 0xA60050
+static const u8 mp_gyro_calib[] =
+{
+	0xab,0x8c,0x00,0xe8,0x24,0xeb,0xf1,0xb8,0x77,0x62,0x52,0x44,0x3e,0x97,0x6f,0x5a,
+	0xf2,0x5e,0x7f,0x6d,0xe3,0xaf,0x9e,0xa4,0x45,0xec,0xe7,0x2f,0x2c,0xb9,0x22,0xb3,
+	0xe1,0x77,0x52,0xdf,0xac,0x6a,0x2e,0x1a,0xf1,0x91,0x63,0x13,0xa7,0xb7,0x86,0xaa,
+	0x6a,0x64,0xbb,0x74,0x7f,0x56,0xa0,0x50,0x9d,0x00,0xdd,0x76,0x97,0xf7,0x3e,0x7a,
+};
+
+static const u8 mp_gyro_calib2[] =
+{
+	0x52,0x16,0x81,0xaf,0xf8,0xad,0x40,0xfd,0xc7,0xb5,0xab,0x33,0xa3,0x38,0x9e,0xdb,
+	0xb0,0xa2,0xcf,0xbf,0x69,0x3a,0xfc,0x78,0x16,0x80,0x4b,0xe0,0x97,0xbd,0x3e,0x58,
+	0x71,0x64,0x88,0x5a,0x44,0x22,0x05,0x00,0x1e,0xa9,0xa5,0x35,0xf1,0xd0,0x0e,0x06,
+	0xa6,0xe9,0x9c,0x6c,0x4b,0xa8,0x2e,0x1a,0xac,0x9a,0x02,0x17,0x54,0xe7,0xba,0x3e,
+};
+
 struct ReportFeatures
 {
 	u8 core, accel, ir, ext, size;
@@ -80,23 +132,18 @@ void EmulateShake(AccelData* const accel_data
 
 void EmulateTilt(AccelData* const accel
 	 , ControllerEmu::Tilt* const tilt_group
-	 , const bool focus, const bool sideways = false, const bool upright = false);
+	 , const bool focus, const bool sideways = false, const bool upright = false
+	 , const bool fast = false);
 
 void EmulateSwing(AccelData* const accel
 	 , ControllerEmu::Force* const tilt_group
 	 , const bool sideways = false, const bool upright = false);
 
-inline double trim(double a)
-{
-	if (a<=0) return 0;
-	if (a>=255) return 255;
-	return a;
-}
-
 class Wiimote : public ControllerEmu
 {
 friend class WiimoteReal::Wiimote;
 friend void Spy(Wiimote* wm_, const void* data_, int size_);
+
 public:
 
 	enum
@@ -114,6 +161,14 @@ public:
 		BUTTON_MINUS =	 0x1000,
 		BUTTON_HOME =	0x8000,
 	};
+	enum
+	{
+		EXT_NONE = 0,
+		EXT_NUNCHUK,
+		EXT_CLASSIC_CONTROLLER,
+		EXT_GUITARHERO,
+		EXT_WBB,
+	};
 
 	Wiimote( const unsigned int index );
 	std::string GetName() const;
@@ -133,6 +188,7 @@ protected:
 	void HandleExtensionSwap();
 	void UpdateButtonsStatus(bool has_focus);
 
+	void GetSettings();
 	void GetCoreData(u8* const data);
 	void GetAccelData(u8* const data, u8* const buttons);
 	void GetIRData(u8* const data, bool use_accel);
@@ -153,13 +209,16 @@ private:
 
 	void ReportMode(const wm_report_mode* const dr);
 	void SendAck(const u8 _reportID);
-	void RequestStatus(const wm_request_status* const rs = NULL);
+	void RequestStatus(const wm_request_status* const rs = NULL, int ext = -1);
 	void ReadData(const wm_read_data* const rd);
 	void WriteData(const wm_write_data* const wd);
 	void SendReadDataReply(ReadRequest& _request);
 	void SpeakerData(wm_speaker_data* sd);
 	bool NetPlay_GetWiimoteData(int wiimote, u8* data, u8 size);
 
+	bool GetMotionPlusAttached() const;
+	bool GetMotionPlusActive() const;
+
 	// control groups
 	Buttons		*m_buttons, *m_dpad, *m_shake;
 	Cursor*			m_ir;
@@ -181,12 +240,12 @@ private:
 
 	bool	m_rumble_on;
 	bool	m_speaker_mute;
-	bool	m_motion_plus_present;
-	bool	m_motion_plus_active;
 
+	bool	mp_passthrough;
 	bool	m_reporting_auto;
 	u8		m_reporting_mode;
 	u16		m_reporting_channel;
+	u8		mp_last_write_reg;
 
 	u8		m_shake_step[3];
 
@@ -207,15 +266,29 @@ private:
 
 	struct MotionPlusReg
 	{
-		u8 unknown[0xF0];
+		u8 unknown1[0x20];
+
+		// address 0x20
+		u8 calibration[0x20];
+
+		// address 0x40
+		u8 ext_calib[0x10];
+
+		// address 0x50
+		u8 gyro_calib[0xA0];
 
 		// address 0xF0
-		u8	activated;
+		u8 activated;
+
+		u8 unknown3[6];
+
+		// address 0xF7
+		u8 state;
 
-		u8 unknown2[9];
+		u8 unknown4[2];
 
 		// address 0xFA
-		u8	ext_identifier[6];
+		u8 ext_identifier[6];
 
 	}	m_reg_motion_plus;
 
@@ -245,6 +318,7 @@ private:
 	}	m_reg_speaker;
 };
 
+extern Wiimote* spy_wm;
 void Spy(Wiimote* wm_, const void* data_, int size_);
 
 }
